<?php
namespace Internetgalerie\IgEmailNoindex\Typolink;

use TYPO3\CMS\Core\LinkHandling\LinkService;
use TYPO3\CMS\Core\Utility\VersionNumberUtility;
use TYPO3\CMS\Frontend\Typolink\EmailLinkBuilder;
use TYPO3\CMS\Frontend\Typolink\LinkResult;
use TYPO3\CMS\Frontend\Typolink\LinkResultInterface;

class MyEmailLinkBuilder extends EmailLinkBuilder {

    protected static bool $removeFromIndexer = false;

    public static function setRemoveFromIndexer(bool $newValue): bool
    {
        $oldValue = static::$removeFromIndexer;
        static::$removeFromIndexer = $newValue;
        return $oldValue;
    }
    
    public function build(array &$linkDetails, string $linkText, string $target, array $conf): LinkResultInterface
    {
        if (VersionNumberUtility::convertVersionNumberToInteger(VersionNumberUtility::getNumericTypo3Version()) >= 12000000) {
            [$url, $linkText, $attributes] = $this->processEmailLink($linkDetails['email'], $linkText, $linkDetails);
        } else {
            [$url, $linkText, $attributes] = $this->contentObjectRenderer->getMailTo($linkDetails['email'], $linkText);
        }

        $attributes['data-nosnippet'] = '1';

        if (static::$removeFromIndexer) {
            $linkText = '<!--TYPO3SEARCH_end-->' . $linkText . '<!--TYPO3SEARCH_begin-->';
        }
        return (new LinkResult(LinkService::TYPE_EMAIL, $url))
            ->withTarget($target)
            ->withLinkConfiguration($conf)
            //->withLinkText('<!--TYPO3SEARCH_end-->' . $linkText . '<!--TYPO3SEARCH_begin-->') // not working in footer (excluded content parts
            ->withLinkText($linkText)
            ->withAttributes($attributes);
    }


}
